<?php namespace App\Models;

use App\Entities\Medicamento\Medicamento;
use App\Utils\DateUtils;

class MedicamentoModel extends ModelEntity
{
    protected $table = 'medicamento';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'nome',
        'quantidade',
        'posologia',
        'id_clinica'
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;
//    protected $createdField  = 'criado_em';
//    protected $updatedField  = 'alterado_em';

    public function registerMedicamento (Medicamento $medicamento) : void {
        $data = $medicamento->toArray(true);
        $id_medicamento = $this->insert($data);
        $medicamento->setId($id_medicamento);
    }

    public function updateMedicamentoByID (int $id_medicamento, Medicamento $medicamento) : bool {
        $data = $medicamento->toArray(true);
        $binds = ['id_medicamento' => $id_medicamento];
        $sets = $this->generateUpdateSets($data, $binds);
        $sql = "update medicamento $sets where medicamento.id = :id_medicamento:";
        $query = $this->db->query($sql, $binds);
        return $query->connID->affected_rows === 1;
    }
}
